open micro_rma

pred bakery [] {

some disj t1, t2: Thread, 
			disj iy1, iy2, ich1, ich2, it12, it13, it14, it21, it23, it24: InitialValue,
			disj wch11, wch10, wy1, wch21, wy2, wch20 : AtomicWrite,
			disj ry1, ry2, rt12, rt13, rt14, rt21, rt23, rt24: AtomicRead,
			disj rgy2, rgch2, rgy2s, rgy1, rgch1, rgy1s: RemoteGet,
			disj vry2, vrch2, vry2s, vry1, vrch1, vry1s: AVirtualRead,
			disj vwy2, vwch2, vwy2s, vwy1, vwch1, vwy1s: AVirtualWrite,
			disj ch1, ch2, y1, y2, t12, t13, t14, t21, t23, t24: MemoryLocation |

/* initial y1 == 0 and y2 == 0 and ch1 == 0 and ch2 == 0; */
	o[iy1] = t1 and d[iy1] = t1 and wl[iy1] = y1 and V[iy1] = 0 and

	o[ich1] = t1 and d[ich1] = t1 and wl[ich1] = ch1 and V[ich1] = 0 and

	o[it12] = t1 and d[it12] = t1 and wl[it12] = t12 and V[it12] = 0 and

	o[it13] = t1 and d[it13] = t1 and wl[it13] = t13 and V[it13] = 0 and

	o[it14] = t1 and d[it14] = t1 and wl[it14] = t14 and V[it14] = 0 and

/* thread T1:

  ch1 = 1; */

	o[wch11] = t1 and d[wch11] = t1 and wl[wch11] = ch1 and V[wch11] = 1 and
/*  t12 = RemoteGet(y2) */
	o[rgy2] = t1 and d[rgy2] = t2 and rgy2 in po[wch11] and
	
	trigger[vry2] = rgy2 and d[vry2] = t2 and rl[vry2] = y2 and
	trigger[vwy2] = rgy2 and d[vwy2] = t1 and wl[vwy2] = t12 and

/*  y1 = t12 + 1; */
	o[rt12] = t1 and d[rt12] = t1 and rl[rt12] = t12 and rt12 in po[rgy2] and 
	o[wy1] = t1 and d[wy1] = t1 and wl[wy1] = y1 and V[wy1] = rV[rt12].plus[1] and wy1 in po[rt12] and

/*  ch1 = 0; */
	o[wch10] = t1 and d[wch10] = t1 and wl[wch10] = ch1 and V[wch10] = 0 and wch10 in po[wy1] and

/*  t13 = RemoteGet(ch2) */
	o[rgch2] = t1 and d[rgch2] = t2 and rgch2 in po[wch10] and
	
	trigger[vrch2] = rgch2 and d[vrch2] = t2 and rl[vrch2] = ch2 and
	trigger[vwch2] = rgch2 and d[vwch2] = t1 and wl[vwch2] = t13 and

/*  assume (t13 == 0) */
	o[rt13] = t1 and d[rt13] = t1 and rl[rt13] = t13 and rt13 in po[rgch2] and
//	(rV[rt13] = 0 or rV[rt13] = Top) and

/*  t11 = y1; */	
	o[ry1] = t1 and d[ry1] = t1 and rl[ry1] = y1 and ry1 in po[rgch2] and

/*  t14 = RemoteGet(y2); */
	o[rgy2s] = t1 and d[rgy2s] = t2 and rgy2s in po[ry1] and
	
	trigger[vry2s] = rgy2s and d[vry2s] = t2 and rl[vry2s] = y2 and
	trigger[vwy2s] = rgy2s and d[vwy2s] = t1 and wl[vwy2s] = t14 and

/*  assume (t14 == 0 or t11 < t14) */
	o[rt14] = t1 and d[rt14] = t1 and rl[rt14] = t14 and rt14 in po[rgy2s] and
//	((rV[rt14] = Top or rV[rt14] = 0) or (rV[ry1] < rV[rt14] or rV[ry1] = Top)) and

/*  -- Critical Section Label -- */


/* ==================================================== */


/* thread T2: */

	o[iy2] = t2 and d[iy2] = t2 and wl[iy2] = y2 and V[iy2] = 0 and

	o[ich2] = t2 and d[ich2] = t2 and wl[ich2] = ch2 and V[ich2] = 0 and

	o[it21] = t2 and d[it21] = t2 and wl[it21] = t21 and V[it21] = 0 and

	o[it23] = t2 and d[it23] = t2 and wl[it23] = t23 and V[it23] = 0 and

	o[it24] = t2 and d[it24] = t2 and wl[it24] = t24 and V[it24] = 0 and

/*  ch2 = 1; */
	o[wch21] = t2 and d[wch21] = t2 and wl[wch21] = ch2 and V[wch21] = 1 and

/*  t21 = RemoteGet(y1) */
	o[rgy1] = t2 and d[rgy1] = t1 and rgy1 in po[wch21] and
	
	trigger[vry1] = rgy1 and d[vry1] = t1 and rl[vry1] = y1 and
	trigger[vwy1] = rgy1 and d[vwy1] = t2 and wl[vwy1] = t21 and

/*  y2 = t21 + 1; */	
	o[rt21] = t2 and d[rt21] = t2 and rl[rt21] = t21 and rt21 in po[rgy1] and
	o[wy2] = t2 and d[wy2] = t2 and wl[wy2] = y2 and V[wy2] = rV[rt21].plus[1] and wy2 in po[rt21] and

/*  ch2 = 0; */
	o[wch20] = t2 and d[wch20] = t2 and wl[wch20] = ch2 and V[wch20] = 0 and wch20 in po[wy2] and

/*  t23 = RemoteGet(ch1) */
	o[rgch1] = t2 and d[rgch1] = t1 and rgch1 in po[wch20] and
	
	trigger[vrch1] = rgch1 and d[vrch1] = t1 and rl[vrch1] = ch1 and
	trigger[vwch1] = rgch1 and d[vwch1] = t2 and wl[vwch1] = t23 and

/*  assume (t23 == 0) */
	o[rt23] = t2 and d[rt23] = t2 and rl[rt23] = t23 and rt23 in po[rgch1] and
//	(rV[rt23] = 0 or rV[rt23] = Top) and

/*  t24 = RemoteGet(y1) */
	o[rgy1s] = t2 and d[rgy1s] = t1 and rgy1s in po[rgch1] and
	
	trigger[vry1s] = rgy1s and d[vry1s] = t1 and rl[vry1s] = y1 and
	trigger[vwy1s] = rgy1s and d[vwy1s] = t2 and wl[vwy2s] = t24 and

/*  t22 = y2; */
	o[ry2] = t2 and d[ry2] = t2 and rl[ry2] = y2 and ry2 in po[rgy1s] and

/*  assume (t24 == 0 or t22 <= t24) */
	o[rt24] = t2 and d[rt24] = t2 and rl[rt24] = t24 and rt24 in po[ry2] and
//	((rV[rt24] = Top or rV[rt24] = 0) or (rV[ry2] <= wV[vwy1s] or rV[ry2] = Top)) and

/*  -- Critical Section Label -- */

	#Item = 42
}

run bakery for 42
