open micro_rma

/*
	T1:						T2:
	X = 1					Y = 2
	flush t2					flush t1
	a = X						b = Y
*/


pred litmus1 [] {
	/* program */
	some disj rx, ry: AtomicRead, 
				disj wx, wy: AtomicWrite, 
				disj f1, f2: Flush, 
				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 
		/* thread 1 */
		o[wx] = t1 and d[wx] = t1 and wl[wx] = x and wV[wx] = 1 and
		o[f1] = t1 and d[f1] = t2 and f1 in po[wx] and
		o[rx] = t1 and d[rx] = t1 and rl[rx] = x and rx in po[f1] and

		/* thread 2 */
		o[wy] = t2 and d[wy] = t2 and wl[wy] = y and wV[wy] = 2 and
		o[f2] = t2 and d[f2] = t1 and f2 in po[wy] and
		o[ry] = t2 and d[ry] = t2 and rl[ry] = y and ry in po[f2] and

		/* spec */
		 not (rV[rx] = 1 and rV[ry] = 2) and

		/* program size */
		#Item = 6
}

run litmus1 for 18


