open micro_rma

/*
	T1:								T2:
	X = 1							Y = 2
	flush t2							flush t1
	X = remoteGet(Y)			Y = remoteGet(X)
*/


pred litmus2 [] {
	/* program */
	some disj rx, ry: RemoteGet, 
				disj wx, wy: AtomicWrite, 
				disj f1, f2: Flush, 
				disj t1, t2: Thread, 
				disj v1, v2, v3, v4: VirtualAction,
				disj x, y: MemoryLocation | 

		/* thread 1 */

		o[wx] = t1 and d[wx] = t1 and wl[wx] = x and V[wx] = 1 and

		o[f1] = t1 and d[f1] = t2 and f1 in po[wx] and

		o[rx] = t1 and d[rx] = t2 and rx in po[f1] and

		trigger[v1] = rx and trigger[v2] = rx and

		v1 in AVirtualRead and rl[v1] = y and d[v1] = t2 and
		
		v2 in AVirtualWrite and wl[v2] = x and d[v2] = t1 and



		/* thread 2 */
		o[wy] = t2 and d[wy] = t2 and wl[wy] = y and V[wy] = 2 and

		o[f2] = t2 and d[f2] = t1 and f2 in po[wy] and

		o[ry] = t2 and d[ry] = t1 and ry in po[f2] and

		trigger[v3] = ry and trigger[v4] = ry and 

		v3 in AVirtualRead and rl[v3] = x and d[v3] = t1 and

		v4 in AVirtualWrite and wl[v4] = y and d[v4] = t2 and 

		/* spec */
		not (wV[v2] = Top or wV[v4] = Top) and

		/* program size */
		#Item = 20
}

run litmus2 for 20
