open micro_rma

/*
	T1:								T2:
	X = 1							Y = 2
	flush t2							flush t1
	X = remoteGet(Y)			Y = remoteGet(X)
	a = X							b = Y
*/


pred litmus3 [] {
	/* program */
	some disj rx, ry: RemoteGet, 
				disj wx, wy: Write, 
				disj ra, rb: Read,
				disj f1, f2: Flush, 
				disj t1, t2: Thread, 
				disj v1, v2: VA,
				disj x, y: MemoryLocation | 
		/* thread 1 */
		o[wx] = t1 and d[wx] = t1 and wl[wx] = x and wV[wx] = 1 and

		o[f1] = t1 and d[f1] = t2 and f1 in po[wx] and

		o[rx] = t1 and d[rx] = t2 and wl[rx] = x and rx in po[f1] and

		rx.virtualOp = v1 and rl[v1] = y and

		o[ra] = t1 and d[ra] = t1 and rl[ra] = x and ra in po[rx] and



		/* thread 2 */
		o[wy] = t2 and d[wy] = t2 and wl[wy] = y and wV[wy] = 2 and

		o[f2] = t2 and d[f2] = t1 and f2 in po[wy] and

		o[ry] = t2 and d[ry] = t1 and wl[ry] = y and ry in po[f2] and

		ry.virtualOp = v2 and rl[v2] = x and

		o[rb] = t2 and d[rb] = t2 and rl[rb] = y and rb in po[ry] and

		/* spec */
		not (rV[ra] = 1 and rV[rb] = 2) and

		/* program size */
		#Item = 10
}

run litmus3 for 18
