open micro_rma

/*
	T1:								T2:
	X = 0							Y = 0
	X = remoteGet(Y)			Z = 0
	X = remoteGet(Z)			Y = 1
	flush t2							Z = 2
	a = X							
*/


pred litmus4 [] {
	/* program */
	some disj rxy, rxz: RemoteGet, 
				disj wx, wy0, wy1, wz0, wz2: AtomicWrite, 
				disj v1, v2, v3, v4: VirtualAction,
				disj ra: AtomicRead,
				disj f1: Flush, 
				disj t1, t2: Thread, 
				disj x, y, z: MemoryLocation | 
		/* thread 1 */
		o[wx] = t1 and d[wx] = t1 and wl[wx] = x and wV[wx] = 0 and

		o[rxy] = t1 and d[rxy] = t2 and wl[rxy] = x and rxy in po[wx] and

		rxy.virtualOp = v1 and rl[v1] = y and

		o[rxz] = t1 and d[rxz] = t2 and wl[rxz] = x and rxz in po[rxy] and

		rxz.virtualOp = v2 and rl[v2] = z and

		o[f1] = t1 and d[f1] = t2 and f1 in po[rxz] and

		o[ra] = t1 and d[ra] = t1 and rl[ra] = x and ra in po[f1] and


		/* thread 2 */
		o[wy0] = t2 and d[wy0] = t2 and wl[wy0] = y and wV[wy0] = 0 and

		o[wz0] = t2 and d[wz0] = t2 and wl[wz0] = z and wV[wz0] = 0 and wz0 in po[wy0] and

		o[wy1] = t2 and d[wy1] = t2 and wl[wy1] = y and wV[wy1] = 1 and wy1 in po[wz0] and

		o[wz2] = t2 and d[wz2] = t2 and wl[wz2] = z and wV[wz2] = 2 and wz2 in po[wy1] and

		/* spec */
		not (rV[ra] = 2 or rV[ra] = 1 or rV[ra] = 0) and

		/* program size */
		#Item = 11
}

run litmus4 for 18
