open simplified_rma

/*
		T1:								T2:
	remotePut(y, 0)		remotePut(x, 0)
	remotePut(y, 1)		remotePut(x, 1)
	flush							flush
	ly = remoteGet y		lx = remoteGet x
	if ly == 1:					if lx == 1:	
	  remotePut(y, 2)	  	  remotePut(x, 2)
	flush							flush
*/

/*
	Observation: in handling conditional branches, we can add
		nop statements to fill in else branches.
*/

pred program2 [] {
	/* program */ 
	some disj rgy, rgx: RemoteGet, 
				disj rpy0, rpy1, rpx0, rpx1: RemotePut, 
				disj f1, f2, f3, f4: Flush, 
				disj t1, t2: Thread, 
				disj x, y: MemoryLocation, 
				disj rpy2, rpx2, v1, v2: Item |

		/* Thread 1 */

		/* rpy0 */
		rpy0.o = t1 and rpy0.d = t2 and 
		rpy0.wl = y and rpy0.V = 0 and

		/* rpy1 */
		rpy1.o = t1 and rpy1.d = t2 and 
		rpy1.wl = y and rpy1.V = 1 and 
		rpy1 in rpy0.po and

		/* f1 */
		f1.o = t1 and f1.d = t2 and 
		f1 in rpy1.po and f1 in rpy1.po and

		/* rgy */
		rgy.o = t1 and rgy.d = t2 and 
		rgy.rl = y and rgy in f1.po and

		/* if ly == 1 */
		(rgy.V = 1 implies

			/* rpy2 */
		(rpy2 in RemotePut and rpy2 in rgy.po and 
			rpy2.o = t1 and rpy2.d = t2 and 
			rpy2.wl = y and rpy2.V = 2 and 
			rpy2.V = 2 and f3 in rpy2.po

			/* vrpy2 */
			and v1 in RemotePut and v1 = rpy2.virtualOp)) and

		/* else */
		(rgy.V != 1 implies 
			(not rpy2 in Action and not v1 in Action and 
				f3 in rgy.po)) and

			/* f3 */
		f3.o = t1 and f3.d = t2 and

		/* Thread 2 */

		/* rpx0 */
		rpx0.o = t2 and rpx0.d = t1 and 
		rpx0.wl = x and rpx0.V = 0 and

		/* rpx1 */
		rpx1.o = t2 and rpx1.d = t1 and 
		rpx1.wl = x and rpx1.V = 1 and 
		rpx1 in rpx0.po and

		/* f2 */
		f2.o = t2 and f2.d = t1 and 
		f2 in rpx1.po and f2 in rpx1.po and 

		/* rgx */
		rgx.o = t2 and rgx.d = t1 and 
		rgx.rl = x and rgx in f2.po and

		/* if lz == 1*/
		(rgx.V = 1 implies

			/* rpx2 */ 
		(rpx2 in RemotePut and rpx2.V = 2 and 
			rpx2.wl = x and rpx2 in rgx.po and 
			rpx2.d = t1 and  rpx2.o = t2 and 
			f4 in rpx2.po

			/* vrpx2 */
			and v2 in VirtualPut and v2 = rpx2.virtualOp)) and

		/* else */
		(rgx.V != 1 implies 
			(not rpx2 in Action and not v2 in Action and 
				f4 in rgx.po)) and

		/* f4 */
		f4.o = t2 and f4.d = t1 and 
		   
		/* spec */
		V[rgx] != V[rgy]
		and #Item = 20
		and #Thread = 2
}

run program2 for 20
