abstract sig Action {
	po, hb : some Action, /* program order */
	o, d : one Thread,
	u : one ProgramLabel
}

abstract sig MA_Type {}

one sig MA_Type_Write extends MA_Type {}
one sig MA_Type_Read extends MA_Type {}
one sig MA_Type_RemotePut extends MA_Type_RPG {}
one sig MA_Type_RemoteGet extends MA_Type_RPG {}
one sig MA_Type_RemoteGetAccumulate extends MA_Type_RA {}
one sig MA_Type_RemoteAccumulate extends MA_Type_RA {}
one sig MA_Type_RemoteCAS extends MA_Type_RA {}

sig Thread {}

sig MemoryLocation {}

sig ProgramLabel {}
/* === Memory action === */
sig MA extends Action{
	t : one MA_Type,
	rl, wl : one MemoryLocation, 
	co : set MA /* partial order */
}

sig MA_Type_RPG extends MA_Type {}
sig MA_Type_RA extends MA_Type {}



abstract sig SA_Type {}

one sig SA_Type_Fence extends SA_Type {}
one sig SA_Type_LockShared extends SA_Type {}
one sig SA_Type_LockExclusive extends SA_Type {}
one sig SA_Type_Unlock extends SA_Type {}
one sig SA_Type_LockAll extends SA_Type {}
one sig SA_Type_UnlockAll extends SA_Type {}
one sig SA_Type_Flush extends SA_Type {}
one sig SA_Type_FlushLocal extends SA_Type {}
one sig SA_Type_FlushAll extends SA_Type {}
one sig SA_Type_FlushLocalAll extends SA_Type {}
one sig SA_Type_WinSync extends SA_Type {}
one sig SA_Type_ExternalSync extends SA_Type {}


/* === Synchronization action === */
sig SA extends Action{
	t : one SA_Type, 
	so : some SA /* total order */
}

/* === Valid Executions === */

fun between[a, b: Action]: set Action{
	{ x: Action| x in po[a] and b in po[x] }
}

pred parallel[a, b: Action, Z : Action -> Action] {
	not (a in Z[b] or b in Z[a])
}

fact a {
	/* not needed, since hb is already the transitive closure */
}

pred isLSorLE[a : SA] {
	t[a] = SA_Type_LockShared or t[a] = SA_Type_LockExclusive
}

fact b1 {
	/* eventually merge ls and le ?*/
	/* is existance of b unique ?*/
	all a: SA | isLSorLE[a] implies 
		one b : SA | (t[b] = SA_Type_Unlock and 
			b in po[a] and 
			d[a] = d[b] and 
			all c : between[a, b] | 
				(t[c] != SA_Type_Fence and (isLSorLE[c] implies d[c] != d[a])))
}

fact b2 {
	all a: SA | t[a] = SA_Type_LockAll implies 
		one b : SA | (t[b] = SA_Type_UnlockAll and 
		b in po[a] and
		all c: between[a, b] | 
			t[c] != SA_Type_Fence and
			t[c] != SA_Type_LockShared and
			t[c] != SA_Type_LockExclusive and
			t[c] != SA_Type_Unlock)
}

fact c {
	/* uniqueness of fe2 ?*/
	all fe: SA | t[fe] = SA_Type_Fence implies
			all j: Thread - o[fe] | 
				one fe2: SA - fe |
					o[fe2] = j and
					parallel[fe, fe2, hb]
}

fact d {
	
}



pred show[] {}

run show for 3
