sig MemoryLocation {}

sig Thread {}

abstract sig Statement {
	l: one MemoryLocation,
	thread: one Thread,
	ord: set Statement,
	co: set Statement
}
{
	not this in ord
}

sig Read extends Statement {
	W: one Write /* encodes rule 6 */
}

sig Write extends Statement {}


fact f1 {
	all i, j: Statement | i!= j implies (j in ord[i] or i in ord[j])
}

fact f2 {
	all i, j: Statement | i in ord[j] implies not j in ord[i]
}

fact f3 {
	all i, j, k: Statement | (j in ord[i] and k in ord[j]) implies k in ord[i]
}

fact f4 {
	all i, j: Statement | (thread[i] = thread[j] and j in ^co[i]) implies j in ord[i]
}

fact f7 {
	all k: Read | l[k] = l[W[k]]
}

fact f8 {
	all k: Read | not W[k] in ord[k]
}

fact f9 {
	/* no write to the same location is ordered between a read and W[read] */
	all k: Read, j: Write | not (l[k] = l[j] and j in ord[W[k]] and k in ord[j])
}

/*InitState facts*/
/*fact f10 {
	all i: Statement - InitState | i in co[InitState]
}*/

pred program1 [] {
	some rx, ry: Read, wx, wy: Write, t1, t2: Thread, x, y: MemoryLocation|
		t1 != t2 and x != y and 
		thread[rx] = t1 and thread[wy] = t1 and 
		thread[ry] = t2 and thread[wx] = t2 and
	  l[rx] = x and l[wx] = x and l[ry] = y and l[wy] = y and
		wy in co[rx] and wx in co[ry]
}

run program1 for 5

/*pred show {}

run show for 5 Statement, 2 MemoryLocation, 2 Thread*/
