open micro_rma

/*
T1:												T2:
X = 0;											Y = 0
X = 1;											Y = 2
m = X;											Y = get(X)
													flush
													put(X, Y)
spec: m is 0 or 1 or 2
*/

pred t11 [] {
	/* program */
	some 	disj wx0, wy0: InitialValue, 
				wx1, wy2: AtomicWrite, 
				rx: AtomicRead,
				rp: RemotePut,
				rg: RemoteGet, 
				vw1: AVirtualWrite,
				vw2: AVirtualWrite,
				vr1: AVirtualRead,
				vr2: AVirtualRead,	
				f: Flush,
				vf: VirtualFlush,

				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 


		/* thread 1 */
		o[wx0] = t1 and wl[wx0] = x and wV[wx0] = 0 and

		o[wx1] = t1 and wl[wx1] = x and wV[wx1] = 1 and

		o[rx] = t1 and rl[rx] = x and rx in po[wx1] and

		/* thread 2 */
		o[wy0] = t2 and wl[wy0] = y and wV[wy0] = 0 and

		o[wy2] = t2 and wl[wy2] = y and wV[wy2] = 2 and

		o[rg] = t2 and d[rg] = t1 and rg in po[wy2] and

		trigger[vr1] = rg and rl[vr1] = x and
		trigger[vw1] = rg and wl[vw1] = y and 

		o[f] = t2 and d[f] = t1 and f in po[rg] and 
		triggerFlush[vf] = f and

		o[rp] = t2 and d[rp] = t1 and rp in po[rg] and

		trigger[vr2] = rp and rl[vr2] = y and
		trigger[vw2] = rp and wl[vw2] = x and


		/* spec */
		(rV[rx] = 2) and
		//#nonDeterministic > 0 and

		/* program size */
		#Item = 13
}

run t11 for 13
