open micro_rma

/*
T1:							T2:
X = 0;						Y = 2
put(Y, X)											
X = 1;											
put(Y, X)
X = get(Y)											
m = X

spec: m is 0 or 1 or 2
*/

pred t15 [] {
	/* program */
	some 	disj wx0: AtomicWrite, 
				wx1: AtomicWrite, 
				wy2: AtomicWrite, 
				rx: AtomicRead,
				rp1, rp2: RemotePut,
				rg: RemoteGet, 
				vw1: AVirtualWrite,
				vw2: AVirtualWrite,
				vw3: AVirtualWrite,
				vr1: AVirtualRead,
				vr2: AVirtualRead,	
				vr3: AVirtualRead,	

				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 


		/* thread 1 */
		o[wx0] = t1 and wl[wx0] = x and wV[wx0] = 0 and

		o[rp1] = t1 and d[rp1] = t2 and rp1 in po[wx0] and

		trigger[vr1] = rp1 and rl[vr1] = x and 
		trigger[vw1] = rp1 and wl[vw1] = y and 

		o[wx1] = t1 and wl[wx1] = x and wV[wx1] = 1 and wx1 in po[rp1] and

		o[rp2] = t1 and d[rp2] = t2 and rp2 in po[wx1] and

		trigger[vr2] = rp2 and rl[vr2] = x and 
		trigger[vw2] = rp2 and wl[vw2] = y and 

		o[rg] = t1 and d[rg] = t2 and rg in po[rp2] and

		trigger[vr3] = rg and rl[vr3] = y and 
		trigger[vw3] = rg and wl[vw3] = x and 

		o[rx] = t1 and rl[rx] = x and rx in po[rg] and

		/* thread 2 */
		o[wy2] = t2 and wl[wy2] = y and wV[wy2] = 2 and

		/* spec */
		not (rV[rx] = 2 or rV[rx] = 1 or rV[rx] = 0) and
		//#nonDeterministic > 0 and

		/* program size */
		#Item = 13
}

run t15 for 13
