open base_rules as b

/* Pivots for rule R1 */
one sig LocalPivot in LocalAction{}
one sig ActionPivot in Action{}

fun poico_prime:LocalAction -> set Action {poico - (LocalPivot->ActionPivot)}

/* consistency order without R1 on Pivots */
pred co_prime[a, b: Action, t: Time] {
	 b in ^(poico_prime + coflushlocal + coexternalflush + cocas1 + cocas2 + coir + 
		coflushexternal + corf + cofr[t] + coput +
		coget + corga1 + corga2 + coinit)[a]
}

/* Hypothesis of PG holds on the pivots */
// no hypothesis
//fact {}

/* F2 rule (coexternflush) */
fact {all f: Flush, e: RemoteAction |
			(f in po[e]) iff 
				(f in coexternalflush[e] and all a: eactions[e] | f in coexternalflush[a])
}

/* CO' is acyclic */
fact { no a: Action | co_prime[a, a, mlast]}

/* CO is cyclic, and the reader pivot is involved in the cycle */
fact {co[LocalPivot, LocalPivot, mlast]}

/* Witness */
one sig Witness in ExternAction {}

pred R1_hypothesis_co[r: Action, w: Action, t: Time] {
			(not (r = w)) and
			(r in (Reader & Atomic)) and
			(w in (Writer & Atomic)) and
			(wl[w] = rl[r]) and 
			co[W[r], w, t] and
			(not (w = W[r]))
}

/* R1 => cofr */
fact{all disj r, w: Action, disj t, t': Time |
			mlt[t, t'] implies ((R1_hypothesis_co[r, w, t]) iff 
				w in cofr[t', r]) 
}

fact {all t: Time, r: Reader| #cofr_prime[t, r] = 0}

/* R2 rule (corf) */
fact {all disj r: Reader, w: Writer| 
			(r in Atomic and w in Atomic and w = W[r]) iff 
				(r in corf[w])
}

/* IR rule - Optional */
fact {all disj e1, e2: RemoteAction | 
		(d[e1] = d[e2] and e2 in po[e1]) iff
			 e2 in coir[e1]
}


