open base_rules as b

/* Pivots for rule ORD */
one sig FirstPivot in RemoteAction{} 
one sig SecondPivot in RemoteAction{}

/* disjoint pivots */
fact { not FirstPivot = SecondPivot }

/* co_ord_prime is a subset of coir */
fun co_ord_prime:RemoteAction -> set RemoteAction {coir - (FirstPivot->SecondPivot)}

/* consistency order without ORD on Pivots */
pred co_prime[a, b: Action, t: Time] {
	 b in ^(poico + coflushlocal + coexternalflush+ cocas1 + cocas2 + co_ord_prime + 
		coflushexternal + corf + cofr[t] + coput +
		coget + corga1 + corga2 + coinit)[a]
}

/* Hypothesis of ORD should hold between pivots */
fact {SecondPivot in po[FirstPivot]}

/* ORD rule */
fact {all disj e1, e2: RemoteAction | 
		(e2 in po[e1]) iff
			 e2 in coir[e1]
}

/* Do not generate Top write values */
fact {all w: Write | not wV[w] = Top}

/* CO' is acyclic */
fact { no a: Action | co_prime[a, a, mlast]}

/* CO is cyclic, and the second pivot is involved in the cycle */
fact {co[SecondPivot, FirstPivot, mlast]}

/* Witness */
one sig Witness in Read {}

pred R1_hypothesis_co[r: Action, w: Action, t: Time] {
			(not (r = w)) and
			(r in (Reader & Atomic)) and
			(w in (Writer & Atomic)) and
			(wl[w] = rl[r]) and 
			co[W[r], w, t] and
			(not (w = W[r]))
}

/* R1 => cofr */
fact{all disj r, w: Action, disj t, t': Time |
			mlt[t, t'] implies ((R1_hypothesis_co[r, w, t]) iff 
				w in cofr[t', r]) 
}

fact {all t: Time, r: Reader| #cofr_prime[t, r] = 0}

/* R2 rule (corf) */
fact {all disj r: Reader, w: Writer| 
			(r in Atomic and w in Atomic and w = W[r]) iff 
				(r in corf[w])
}

/* F2 rule (coexternflush) */
fact {all f: Flush, e: RemoteAction |
//			(f in po[e] and d[f] = d[e]) iff 
			/* Make the flush total, as it is in DMAPP */
			(f in po[e]) iff 
				(f in coexternalflush[e] and all a: eactions[e] | f in coexternalflush[a])
}
