open base_rules as b

/* Pivots for rule RGA2 */
one sig RemotePivot in RemoteReadWrite{}
one sig ExternalPivot in ExternWrite{}

/* Witness */
one sig Witness in ExternAction {}

fun corga2_prime:RemoteReadWrite -> ExternWrite {corga2 - (RemotePivot->ExternalPivot)}

/* consistency order without RGA2 on Pivots */
pred co_prime[a, b: Action, t: Time] {
	 b in ^(poico + coflushlocal + coexternalflush + cocas1 + cocas2 + coir + 
		coflushexternal + corf + cofr[t] + coput +
		coget + corga1 + corga2_prime + coinit)[a]
}

/* Hypothesis of RGA2 holds on the pivots */
fact {(~actions[ExternalPivot] = ~actions[RemotePivot] and 
		 ~actions[ExternalPivot] in Rga)}

/* F2 rule (coexternflush) */
fact {all f: Flush, e: RemoteAction |
			(f in po[e]) iff 
				(f in coexternalflush[e] and all a: eactions[e] | f in coexternalflush[a])
}

/* Do not generate Top write values */
fact {all w: Write | not wV[w] = Top}

/* CO' is acyclic */
fact { no a: Action | co_prime[a, a, mlast]}

/* CO is cyclic, and the reader pivot is involved in the cycle */
fact {co[RemotePivot, RemotePivot, mlast]}

pred R1_hypothesis_co[r: Action, w: Action, t: Time] {
			(not (r = w)) and
			(r in (Reader & Atomic)) and
			(w in (Writer & Atomic)) and
			(wl[w] = rl[r]) and 
			co[W[r], w, t] and
			(not (w = W[r]))
}

/* R1 => cofr */
fact{all disj r, w: Action, disj t, t': Time |
			mlt[t, t'] implies ((R1_hypothesis_co[r, w, t]) iff 
				w in cofr[t', r]) 
}

fact {all t: Time, r: Reader| #cofr_prime[t, r] = 0}

/* R2 rule (corf) */
fact {all disj r: Reader, w: Writer| 
			(r in Atomic and w in Atomic and w = W[r]) iff 
				(r in corf[w])
}

/* IR rule - Optional */
fact {all disj e1, e2: RemoteAction | 
		(d[e1] = d[e2] and e2 in po[e1]) iff
			 e2 in coir[e1]
}


