NOTE: this documentation is out of date.

Intermediate Representation
===========================

- Assertions contain only local variables (registers), no shared variables.
- Each local variable (register) can be assigned at most once.
- Assertions and assumptions are not allowed inside IF blocks.
- IF statements do not allow ELSE branches.

How to use
==========

1) Use `gradle build` to compile the sources.

2) Run the `Main` class to check assertions:

```bash
java -cp build/classes/main/:build/libs/antlr4-runtime-4.5.jar:build/libs/alloy4.2.jar Main benchmarks/t11.tl
```

For DMAPP, make sure that the template in src/main/resources/dmapp_template.c contains the 
appropriate setting for the ROUTING guarantees:

rma_args.put_relaxed_ordering = DMAPP_ROUTING_IN_ORDER;
(ordering of remote actions regardless of the target process)
or

rma_args.put_relaxed_ordering = DMAPP_ROUTING_DETERMINISTIC;
(ordering of remote actions for the same target process)
or 

rma_args.put_relaxed_ordering = DMAPP_ROUTING_ADAPTIVE;
(no ordering guarantees)

Mass builds/executions
======================

* Run the `ConvertToRma` class to generate IBV_Verbs code:

```java -cp build/libs/parser.jar:build/libs/antlr4-runtime-4.5.jar ConvertToRma ../testgen/output/driver000001.ir output_folder
```

* Batch-process all of the IR files in a directory (single-host):

```for c in /tmp/IR-11-2p/*.ir; do java -cp build/libs/parser.jar:build/libs/antlr4-runtime-4.5.jar ConvertToRma $c `basename $c`; done
for c in output/driver*.ir; do ( cd $c; make ); done
for c in output/driver_F10*.ir; do ( cd $c; timeout 60s ./rdma-starter >& ../output-`basename $c` ); done
```

If you are trying to run a `1p` IR file, run `rdma-single` rather than `rdma-starter`.

For multiple hosts, after make, scp the whole directory to the remote host. Make sure -DUSE_SSH_FOR_RDMA_STARTER=1 is in Makefile.

* The conversion and compilation steps are encapsulated in the `bin/compile_portals_ir` script.

* Run the `ConvertToPortals` class to generate Portals code:

```for c in ../testgen/outputR2/*.ir; do java -cp build/libs/parser.jar:build/libs/antlr4-runtime-4.5.jar ConvertToPortals $c `basename $c`; done
```

* Compile the portals code:

```for c in `ls`; do ( cd $c; mpicc -lportals portals_test_generated.c; ) done
```

The execution is encapsulated in the `bin/run_portals` script:

```for c in `ls`; do ( cd $c; echo $c >> ../results; timeout 60s mpirun -np 2 ./a.out >> ../results; echo result: $? >> ../results ) done
```

