import java.util.List;
import java.util.Map;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * Created by andrei on 8/30/15.
 */
public class TranslateValue {
    StringBuffer programBuffer, ARead, AWrite, NRead, NWrite, ARemoteRead, ARemoteWrite, NRemoteRead, NRemoteWrite, ARemoteReadWrite, NRemoteReadWrite,
                 AExternRead, AExternWrite, NExternRead, NExternWrite, MemoryLocation, Processes, InitialValue, Flushes, Integers, Assertion, Items;
    int actionsNumber;
    boolean check_robustness;

    public TranslateValue() {
        this.actionsNumber = 0;
        this.programBuffer = new StringBuffer();
        this.ARead = new StringBuffer();
        this.AWrite = new StringBuffer();
        this.NRead = new StringBuffer();
        this.NWrite = new StringBuffer();
        this.ARemoteRead = new StringBuffer();
        this.ARemoteWrite = new StringBuffer();
        this.NRemoteRead = new StringBuffer();
        this.NRemoteWrite = new StringBuffer();
        this.ARemoteReadWrite = new StringBuffer();
        this.NRemoteReadWrite = new StringBuffer();
        this.AExternRead = new StringBuffer();
        this.AExternWrite = new StringBuffer();
        this.NExternRead = new StringBuffer();
        this.NExternWrite = new StringBuffer();
        this.MemoryLocation = new StringBuffer();
        this.Processes = new StringBuffer();
        this.InitialValue = new StringBuffer();
        this.Flushes = new StringBuffer();
        this.Integers = new StringBuffer();
        this.Assertion = new StringBuffer();
        this.Items = new StringBuffer();
    }

    /* propertyFlag values
    *   0: ignore assertions and do not add robustness criteria
    *   1: add assertions if any, but do not add robustness criteria if assertions are absent
    *   2: add assertions if any, and add robustness criteria if assertions are absent */
    public String toString(int propertyFlag, String additionalConstraints) {
        StringBuffer result = new StringBuffer();

        result.append("open stability_check\n\n");
        result.append("pred Test [] {\n");
        result.append(" some ");
        if (InitialValue.length() > 0) {
            result.append("disj " + InitialValue.toString() + ": InitialValue,\n");
        }
        if (Integers.length() > 0) {
            result.append("disj " + Integers.toString() + ": Register,\n");
        }
        if (ARead.length() > 0) {
            result.append("disj " + ARead.toString() + ": ARead,\n");
        }
        if (AWrite.length() > 0) {
            result.append("disj " + AWrite.toString() + ": (AWrite - InitialValue),\n");
        }
        if (NRead.length() > 0) {
            result.append("disj " + NRead.toString() + ": NRead,\n");
        }
        if (NWrite.length() > 0) {
            result.append("disj " + NWrite.toString() + ": NWrite,\n");
        }
        if (ARemoteRead.length() > 0) {
            result.append("disj " + ARemoteRead.toString() + ": ARemoteRead,\n");
        }
        if (ARemoteWrite.length() > 0) {
            result.append("disj " + ARemoteWrite.toString() + ": ARemoteWrite,\n");
        }
        if (NRemoteRead.length() > 0) {
            result.append("disj " + NRemoteRead.toString() + ": NRemoteRead,\n");
        }
        if (NRemoteWrite.length() > 0) {
            result.append("disj " + NRemoteWrite.toString() + ": NRemoteWrite,\n");
        }
        if (ARemoteReadWrite.length() > 0) {
            result.append("disj " + ARemoteReadWrite.toString() + ": ARemoteReadWrite,\n");
        }
        if (NRemoteReadWrite.length() > 0) {
            result.append("disj " + NRemoteReadWrite.toString() + ": NRemoteReadWrite,\n");
        }
        if (AExternRead.length() > 0) {
            result.append("disj " + AExternRead.toString() + ": AExternRead,\n");
        }
        if (AExternWrite.length() > 0) {
            result.append("disj " + AExternWrite.toString() + ": AExternWrite,\n");
        }
        if (NExternRead.length() > 0) {
            result.append("disj " + NExternRead.toString() + ": NExternRead,\n");
        }
        if (NExternWrite.length() > 0) {
            result.append("disj " + NExternWrite.toString() + ": NExternWrite,\n");
        }
        if (Flushes.length() > 0) {
            result.append("disj " + Flushes.toString() + ": Flush,\n");
        }
        if (Items.length() > 0) {
            result.append("disj " + Items.toString() + ": Item,\n");
        }
        if (MemoryLocation.length() > 0) {
            result.append("disj " + MemoryLocation.toString() + ": MemoryLocation,\n");
        }

        result.append("disj " + Processes.toString() + ": Thr | \n");

        result.append(" #Item = " + actionsNumber + "\n");

        if (propertyFlag > 0) {
            if (Assertion.length() > 0) {
            /* Check assertion */
                result.append(" and not (" + Assertion.toString() + ")\n");
                this.check_robustness = false;
            } else if (propertyFlag > 1) {
            /* Check robustness */
                result.append(" and Robust.is_robust = 0 \n");
                this.check_robustness = true;
            }
        }

        if (additionalConstraints != null) {
            result.append(" and " + additionalConstraints + "\n");
        }


        result.append(programBuffer);

        result.append("}\n\n");

        result.append("run Test for " + actionsNumber + "\n");


        return result.toString();
    }
}
