open micro_rma

/*
T1:									T2:
Y = 1								X = 0
RemotePut(X, Y)				a = X
flush								assume (a != 0)

spec: a should be 1
*/

pred t1 [] {
	/* program */
	some 	rx: AtomicRead, 
				disj wy: Write, wx: AtomicWrite,
				rp : RemotePut,
				vw: AVirtualWrite,
				vr: VirtualRead,
				f1: Flush, 
				vf: VirtualFlush,
				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 


		/* thread 1 */
		o[wy] = t1 and d[wy] = t1 and wl[wy] = y and V[wy] = 1 and

		o[rp] = t1 and d[rp] = t2 and rp in po[wy] and

		trigger[vr] = rp and rl[vr] = y and d[vr] = t1 and
		trigger[vw] = rp and wl[vw] = x and d[vw] = t2 and

		o[f1] = t1 and d[f1] = t2 and f1 in po[rp] and
		triggerFlush[vf] = f1 and

		/* thread 2 */
		o[wx] = t2 and d[wx] = t2 and wl[wx] = x and V[wx] = 0 and

		o[rx] = t2 and d[rx] = t2 and rl[rx] = x and rx in po[wx] and

		not (rV[rx] = 0) and

		/* spec */
		not (rV[rx] = 1) and
		//#nonDeterministic > 0 and

		/* program size */
		#Item = 8
}

run t1 for 8
