open micro_rma

/*
T1:												T2:
Y = 0											X = 0
Z = 1											a = X
RemotePut(X, Z)							
Y = RemoteGet(X)
flush
Z = 5
RemotePut(X, Z)

spec: a is 0 or 1 or 5

*/

pred t10 [] {
	/* program */
	some 	rx: AtomicRead, 
				disj wx, wz1, wy, wz5: AtomicWrite, 
				rp1, rp2: RemotePut,
				rg: RemoteGet,
				vw1, vw2, vw3: AVirtualWrite,
				vr1, vr2, vr3: AVirtualRead,
				f1: Flush, 
				vf: VirtualFlush,
				disj t1, t2: Thread, 
				disj x, y, z: MemoryLocation | 


		/* thread 1 */
		o[wy] = t1 and d[wy] = t1 and wl[wy] = y and V[wy] = 0 and

		o[wz1] = t1 and d[wz1] = t1 and wl[wz1] = z and V[wz1] = 1 and wz1 in po[wy] and

		o[rp1] = t1 and d[rp1] = t2 and rp1 in po[wz1] and

		trigger[vr1] = rp1 and rl[vr1] = z and d[vr1] = t1 and
		trigger[vw1] = rp1 and wl[vw1] = x and d[vw1] = t2 and

		o[rg] = t1 and d[rg] = t2 and rg in po[rp1] and

		trigger[vr2] = rg and rl[vr2] = x and d[vr2] = t2 and
		trigger[vw2] = rg and wl[vw2] = y and d[vw2] = t1 and


		o[f1] = t1 and d[f1] = t2 and f1 in po[rg] and
		triggerFlush[vf] = f1 and

		o[wz5] = t1 and d[wz5] = t1 and wl[wz5] = z and V[wz5] = 5 and wz5 in po[f1] and

		o[rp2] = t1 and d[rp2] = t2 and rp2 in po[wz5] and

		trigger[vr3] = rp2 and rl[vr3] = z and d[vr3] = t1 and
		trigger[vw3] = rp2 and wl[vw3] = x and d[vw3] = t2 and


		/* thread 2 */
		o[wx] = t2 and d[wx] = t2 and wl[wx] = x and V[wx] = 0 and

		o[rx] = t2 and d[rx] = t2 and rl[rx] = x and rx in po[wx] and

		/* spec */
		//not (rV[rx] = 1 or rV[rx] = 0 or rV[rx] = 5) and
		#nonDeterministic > 0 and 

		/* program size */
		#Item = 16
}

run t10 for 16
