open micro_rma

/*
T1:					T2:						T3:				T4:
X = 0;				A1 = get(Y)					B1 = get(Y)
put(Y, X)			A2 = get(Y)					B2 = get(Y)
Z = 1;
put(Y, Z)				

spec: it cannot be (A1 = B2 = 0 and A2 = B1 = 1) or (A1 = B2 = 1 and A2 = B1 = 0)

*/

pred t12 [] {
	/* program */
	some 	disj wx0, wz0: InitialValue, 
				disj rp1, rp2: RemotePut,
				disj rg1, rg2, rg3, rg4: RemoteGet, 
				disj vr1: VirtualRead, 
				vr2: VirtualRead, 
				vr3: AVirtualRead, 
				vr4: AVirtualRead, 
				vr5: AVirtualRead, 
				vr6: AVirtualRead,
				disj vw1: AVirtualWrite, 
				vw2: AVirtualWrite, 
				vw3: VirtualWrite, 
				vw4: VirtualWrite, 
				vw5: VirtualWrite, 
				vw6: VirtualWrite,	
				disj t1, t2, t3, t4: Thread, 
				disj x, y, z, lt2, llt2, lt3, llt3: MemoryLocation | 


		/* thread 1 */
		o[wx0] = t1 and d[wx0] = t1 and wl[wx0] = x and V[wx0] = 0 and
		o[wz0] = t1 and d[wz0] = t1 and wl[wz0] = z and V[wz0] = 0 and

		o[rp1] = t1 and d[rp1] = t4 and

		trigger[vr1] = rp1 and rl[vr1] = x and d[vr1] = t1 and
		trigger[vw1] = rp1 and wl[vw1] = y and d[vw1] = t4 and

		o[rp2] = t1 and d[rp2] = t4 and

		trigger[vr2] = rp2 and rl[vr2] = z and d[vr2] = t1 and
		trigger[vw2] = rp2 and wl[vw2] = y and d[vw2] = t4 and

		/* thread 2 */
		o[rg1] = t2 and d[rg1] = t4 and

		trigger[vr3] = rg1 and rl[vr3] = y and d[vr3] = t4 and
		trigger[vw3] = rg1 and wl[vw3] = lt2 and d[vw3] = t2 and 

		o[rg2] = t2 and d[rg2] = t4 and rg2 in po[rg1] and

		trigger[vr4] = rg2 and rl[vr4] = y and d[vr4] = t4 and
		trigger[vw4] = rg2 and wl[vw4] = llt2 and d[vw4] = t2 and 

		/* thread 3 */
		o[rg3] = t3 and d[rg3] = t4 and

		trigger[vr5] = rg3 and rl[vr5] = y and d[vr5] = t4 and
		trigger[vw5] = rg3 and wl[vw5] = lt3 and d[vw5] = t3 and 

		o[rg4] = t3 and d[rg4] = t4 and rg4 in po[rg3] and

		trigger[vr6] = rg4 and rl[vr6] = y and d[vr6] = t4 and
		trigger[vw6] = rg4 and wl[vw6] = llt3 and d[vw6] = t3 and 


		/* spec */
		((rV[vr3] = rV[vr6] and rV[vr6] = 1 and rV[vr4] =rV[vr5] and rV[vr5] = 0) or (rV[vr3] = rV[vr6] and rV[vr6] = 0 and rV[vr4] =rV[vr5] and rV[vr5] = 1 ) or
		rV[vr3] = Top or rV[vr4] = Top or rV[vr5] = Top or rV[vr6] = Top) and
		//#nonDeterministic > 0 and

		/* program size */
		#Item = 20
}

run t12 for 20
