open micro_rma

/*
T1:												T2:
X = 0;											Y = 0
X = 1;											Y = 2
put(Y, X)										Y = get(X)
X = get(Y)										flush
													put(X, Y)
											m = Y
										
													
spec: m is 0 or 1 or 2
*/

pred t14 [] {
	/* program */
	some 	disj wx0, wy0: InitialValue, 
				wx1: AtomicWrite, 
				wy2: AtomicWrite, 
				rp, rp_t1: RemotePut,
				rg, rg_t1: RemoteGet, 
				vw1: AVirtualWrite, 
				vw1_t1: AVirtualWrite,
				vw2: AVirtualWrite, 
				vw2_t1: AVirtualWrite,
				vr1: AVirtualRead, 
				vr1_t1: AVirtualRead,
				vr2: AVirtualRead, 
				vr2_t1: AVirtualRead,	
				f: Flush,
				vf: VirtualFlush,

				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 


		/* thread 1 */
		o[wx0] = t1 and d[wx0] = t1 and wl[wx0] = x and V[wx0] = 0 and

		o[wx1] = t1 and d[wx1] = t1 and wl[wx1] = x and V[wx1] = 1 and

		o[rp_t1] = t1 and d[rp_t1] = t2 and rp_t1 in po[wx1] and

		trigger[vr2_t1] = rp_t1 and rl[vr2_t1] = x and d[vr2_t1] = t1 and
		trigger[vw2_t1] = rp_t1 and wl[vw2_t1] = y and d[vw2_t1] = t2 and

		o[rg_t1] = t1 and d[rg_t1] = t2 and rg_t1 in po[rp_t1] and

		trigger[vr1_t1] = rg_t1 and rl[vr1_t1] = y and d[vr1_t1] = t2 and
		trigger[vw1_t1] = rg_t1 and wl[vw1_t1] = x and d[vw1_t1] = t1 and 


		/* thread 2 */
		o[wy0] = t2 and d[wy0] = t2 and wl[wy0] = y and V[wy0] = 0 and

		o[wy2] = t2 and d[wy2] = t2 and wl[wy2] = y and V[wy2] = 2 and

		o[rg] = t2 and d[rg] = t1 and rg in po[wy2] and

		trigger[vr1] = rg and rl[vr1] = x and d[vr1] = t1 and
		trigger[vw1] = rg and wl[vw1] = y and d[vw1] = t2 and 

		o[f] = t2 and d[f] = t1 and f in po[rg] and
		triggerFlush[vf] = f and

		o[rp] = t2 and d[rp] = t1 and rp in po[f] and

		trigger[vr2] = rp and rl[vr2] = y and d[vr2] = t2 and
		trigger[vw2] = rp and wl[vw2] = x and d[vw2] = t1 and


		/* spec */
		not (rV[vr1_t1] = 2 or rV[vr1_t1] = 1 or rV[vr1_t1] = 0) and
		//#nonDeterministic > 0 and

		/* program size */
		#Item = 18
}

run t14 for 18
