open micro_rma

/*
T1:			T2:
Y = 1;			X = 0
Y = RemoteGet(X)
a = Y
flush

spec: a must be 0 or 1 (if local atomic, else undefined)
*/

pred t2 [] {
	/* program */
	some ry: AtomicRead, 
				disj wx, wy: AtomicWrite, 
				rg: RemoteGet,
				vw: AVirtualWrite,
				vr: AVirtualRead,
				f: Flush, 
				vf: VirtualFlush,
				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 


		/* thread 1 */
		o[wy] = t1 and d[wy] = t1 and wl[wy] = y and V[wy] = 1 and

		o[rg] = t1 and d[rg] = t2 and rg in po[wy] and
		trigger[vr] = rg and rl[vr] = x and d[vr] = t2 and
		trigger[vw] = rg and wl[vw] = y and d[vw] = t1 and

		o[ry] = t1 and d[ry] = t1 and rl[ry] = y and ry in po[rg] and

		o[f] = t1 and d[f] = t2 and f in po[ry] and triggerFlush[vf] = f and


		/* thread 2 */
		o[wx] = t2 and d[wx] = t2 and wl[wx] = x and V[wx] = 0 and

		/* spec */
		//not (rV[ry] = 1 or rV[ry] = 0) and
		#nonDeterministic > 0 and

		/* program size */
		#Item = 8
}

run t2 for 8
