open micro_rma

/*
T1:												T2:
Y = 1;											X = 0
AtomicRemotePut(X, Y)					a = X
flush

spec: a must be 0 or 1 (if local atomic, else undefined)
*/

pred t6 [] {
	/* program */
	some 	rx: AtomicRead, 
				disj wx0, wy: AtomicWrite, 
				rp: RemotePut,
				vw: AVirtualWrite,
				vr: AVirtualRead,
				f: Flush, 
				vf: VirtualFlush,
				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 


		/* thread 1 */
		o[wy] = t1 and d[wy] = t1 and wl[wy] = y and V[wy] = 1 and

		o[rp] = t1 and d[rp] = t2 and rp in po[wy] and
		trigger[vr] = rp and rl[vr] = y and d[vr] = t1 and
		trigger[vw] = rp and wl[vw] = x and d[vw] = t2 and

		o[f] = t1 and d[f] = t2 and f in po[rp] and
		triggerFlush[vf] = f and


		/* thread 2 */
		o[wx0] = t2 and d[wx0] = t2 and wl[wx0] = x and V[wx0] = 0 and
		o[rx] = t2 and d[rx] = t2 and rl[rx] = x and rx in po[wx0] and

		/* spec */
		//not (rV[rx] = 1 or rV[rx] = 0) and
		#nonDeterministic > 0 and

		/* program size */
		#Item = 8
}

run t6 for 8
