open micro_rma

/*
Litmus 7
T1:												T2:
Y = 1;											X = 0
RemotePut(X, Y)							X = 2
flush
Y = RemoteGet(X)
flush
a = Y

spec: a should be 0 or 1 or 2

*/

pred t7 [] {
	/* program */
	some 	ry: AtomicRead, 
				disj wx0, wx2, wy: AtomicWrite, 
				rp: RemotePut,
				rg: RemoteGet,
				vw1, vw2: AVirtualWrite,
				vr1, vr2: AVirtualRead,
				f1, f2: Flush, 
				vf1, vf2: VirtualFlush,
				disj t1, t2: Thread, 
				disj x, y: MemoryLocation | 


		/* thread 1 */
		o[wy] = t1 and d[wy] = t1 and wl[wy] = y and V[wy] = 1 and

		o[rp] = t1 and d[rp] = t2 and rp in po[wy] and

		trigger[vr1] = rp and rl[vr1] = y and d[vr1] = t1 and
		trigger[vw1] = rp and wl[vw1] = x and d[vw1] = t2 and

		o[f1] = t1 and d[f1] = t2 and f1 in po[rp] and
		triggerFlush[vf1] = f1 and

		o[rg] = t1 and d[rg] = t2 and rg in po[f1] and

		trigger[vr2] = rg and rl[vr2] = x and d[vr2] = t2 and
		trigger[vw2] = rg and wl[vw2] = y and d[vw2] = t1 and

		o[f2] = t1 and d[f2] = t2 and f2 in po[rg] and
		triggerFlush[vf2] = f2 and

		o[ry] = t1 and d[ry] = t1 and rl[ry] = y and ry in po[f2] and


		/* thread 2 */
		o[wx0] = t2 and d[wx0] = t2 and wl[wx0] = x and V[wx0] = 0 and
		o[wx2] = t2 and d[wx2] = t2 and wl[wx2] = x and 
			V[wx2] = 2 and wx2 in po[wx0] and

		/* spec */
		//not (rV[ry] = 2 or rV[ry] = 1 or rV[ry] = 0) and
		#nonDeterministic > 0 and

		/* program size */
		#Item = 14
}

run t7 for 14
