open micro_rma

/*
T1:												T2:
Y = 0;											X = 0
Z = 1;											V = 2
RemotePut(X, Z)							RemotePut(Y, V)
flush												b = X
a = Y

spec: a is 0 or 2 and b is 0 or 1
*/

pred t8 [] {
	/* program */
	some 	rx, ry: AtomicRead, 
				disj wx, wz, wy, wv: AtomicWrite, 
				rpx, rpy: RemotePut,
				vwx, vwy: AVirtualWrite,
				vrx, vry: AVirtualRead,
				f1: Flush, 
				vf: VirtualFlush,
				disj t1, t2: Thread, 
				disj x, y, z, v: MemoryLocation | 


		/* thread 1 */
		o[wy] = t1 and d[wy] = t1 and wl[wy] = y and V[wy] = 0 and

		o[wz] = t1 and d[wz] = t1 and wl[wz] = z and V[wz] = 1 and wz in po[wy] and

		o[rpx] = t1 and d[rpx] = t2 and rpx in po[wz] and

		trigger[vrx] = rpx and rl[vrx] = z and d[vrx] = t1 and
		trigger[vwx] = rpx and wl[vwx] = x and d[vwx] = t2 and

		o[f1] = t1 and d[f1] = t2 and f1 in po[rpx] and
		triggerFlush[vf] = f1 and

		o[ry] = t1 and d[ry] = t1 and rl[ry] = y and ry in po[f1] and


		/* thread 2 */
		o[wx] = t2 and d[wx] = t2 and wl[wx] = x and V[wx] = 0 and

		o[wv] = t2 and d[wv] = t2 and wl[wv] = v and 
			V[wv] = 2 and wv in po[wx] and

		o[rpy] = t2 and d[rpy] = t1 and rpy in po[wv] and

		trigger[vry] = rpy and rl[vry] = v and d[vry] = t2 and
		trigger[vwy] = rpy and wl[vwy] = y and d[vwy] = t1 and

		o[rx] = t2 and d[rx] = t2 and rl[rx] = x and rx in po[rpy] and

		/* spec */
		//not ((rV[ry] = 2 or rV[ry] = 0) and ( rV[rx] = 0 or rV[rx] = 1)) and
		#nonDeterministic > 0 and

		/* program size */
		#Item = 14
}

run t8 for 14
