open micro_rma

/*
T1:												T2:
Y = 0;											X = 0
Z = 1;											X = 3
RemotePut(X, Z)							
Y = RemoteGet(X)
flush												
a = Y

spec: a is 0 or 1 or 3
*/

pred t9 [] {
	/* program */
	some 	ry: Read, 
				disj wx0, wx3: AtomicWrite, 
				wy: Write,
				wz: Write,
				rp: RemotePut,
				rg: RemoteGet, 
				vw1: AVirtualWrite,
				vw2: VirtualWrite,
				vr1: VirtualRead,
				vr2: AVirtualRead,	
				f1: Flush, 
				vf: VirtualFlush,
				disj t1, t2: Thread, 
				disj x, y, z: MemoryLocation | 


		/* thread 1 */
		o[wy] = t1 and d[wy] = t1 and wl[wy] = y and V[wy] = 0 and

		o[wz] = t1 and d[wz] = t1 and wl[wz] = z and V[wz] = 1 and wz in po[wy] and

		o[rp] = t1 and d[rp] = t2 and rp in po[wz] and

		trigger[vr1] = rp and rl[vr1] = z and d[vr1] = t1 and
		trigger[vw1] = rp and wl[vw1] = x and d[vw1] = t2 and

		o[rg] = t1 and d[rg] = t2 and rg in po[rp] and

		trigger[vr2] = rg and rl[vr2] = x and d[vr2] = t2 and
		trigger[vw2] = rg and wl[vw2] = y and d[vw2] = t1 and 

		o[f1] = t1 and d[f1] = t2 and f1 in po[rg] and
		triggerFlush[vf] = f1 and

		o[ry] = t1 and d[ry] = t1 and rl[ry] = y and ry in po[f1] and


		/* thread 2 */
		o[wx0] = t2 and d[wx0] = t2 and wl[wx0] = x and V[wx0] = 0 and

		o[wx3] = t2 and d[wx3] = t2 and wl[wx3] = x and V[wx3] = 3 and
				wx3 in po[wx0] and

		/* spec */
		//not (rV[ry] = 1 or rV[ry] = 0 or rV[ry] = 3) and
		#nonDeterministic > 0 and

		/* program size */
		#Item = 13
}

run t9 for 13
