#!/usr/bin/env bash

case $(id -u) in
    0)
	# Update to stretch
	sed -i "s/jessie main\$/stretch main contrib non-free/g" /etc/apt/sources.list
	sed -i "s/updates main\$/updates main contrib non-free/g" /etc/apt/sources.list
	apt-get update

	# futzing
	echo "set grub-pc/install_devices /dev/sda" | debconf-communicate
	sed -i "s/GRUB_TIMEOUT=0/GRUB_TIMEOUT=5/g" /etc/default/grub
	apt-get -y -qq -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" upgrade
	sed -i "s/GRUB_TIMEOUT=5/GRUB_TIMEOUT=0/g" /etc/default/grub

	# packages
	apt-get upgrade
        apt-get install -y git libtool autoconf libev-dev libopenmpi-dev unzip gradle openmpi-bin openjdk-8-jdk

	# ldconfig
	echo /usr/local/lib > /etc/ld.so.conf.d/99local.conf
	/sbin/ldconfig

        sudo -u vagrant -i $0
        ;;
    *)
        mkdir -p hacking
        cd hacking

	# install portals
	git clone --depth 10 https://github.com/regrant/portals4.git
	cd portals4
	./autogen.sh
	./configure --enable-zero-mrs
	make
	sudo make install

	# install rma-alloy
	cd ..
	tar xjf /vagrant_data/rma-alloy.tar.bz2

	# build rma-alloy
	cd ~/hacking/rma-alloy/testgen
	gradle jar
	cd ~/hacking/rma-alloy/parser
	gradle jar

        ;;
esac
